#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char decode(const char c, const int key)
{
    if (islower(c))
    {
        // 26 + et key % 26 pour être sûr de ne pas se retrouver avec une valeur négative après la soustraction
        return ((26 + c - 'a' - (key % 26)) % 26) + 'a';
    }
    else if (isupper(c))
    {
        // 26 + et key % 26 pour être sûr de ne pas se retrouver avec une valeur négative après la soustraction
        return ((26 + c - 'A' - (key % 26)) % 26) + 'A';
    }
    else
    {
        return c;
    }
}

int main(int argc, char* argv[])
{
    if (argc != 3)
    {
        printf("%s <cle> <chaine>\n", argv[0]);
        return EXIT_FAILURE;
    }

    const int key = atoi(argv[1]);

    for (int i = 0; i < strlen(argv[2]); i++)
    {
        printf("%c", decode(argv[2][i], key));
    }
    printf("\n");

    return EXIT_SUCCESS;
}
